/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 08/12/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.CaraBayar;
import com.portofolio.entity.vo.CaraBayarId;

@Lazy
@Repository("carabayarDao")
public interface CaraBayarDao extends CrudRepository<CaraBayar, CaraBayarId> {

	@Cacheable("CaraBayarDaofindOneBy")
	CaraBayar findOneByIdKodeAndIdKdProfileAndKdDepartemen(Integer kode, Integer kdProfile, String KdDepartemen);

	@Query(QListAll + " and model.namaCaraBayar like %:namaCaraBayar% and model.kdCaraBayarHead is null ")
	@Cacheable("CaraBayarDaoFindAllList")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,
			@Param("namaCaraBayar") String namaCaraBayar, Pageable page, @Param("kdDepartemen") String kdDepartemen);

	@Query(QListAll + " and model.namaCaraBayar like %:namaCaraBayar% and model.kdCaraBayarHead=:kdCaraBayarHead ")
	@Cacheable("CaraBayarDaoFindAllListPage")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,
			@Param("namaCaraBayar") String namaCaraBayar, Pageable page, @Param("kdDepartemen") String kdDepartemen,
			@Param("kdCaraBayarHead") Integer kdCaraBayarHead);

	@Query(QListAll + " and model.id.kode = :kode")
	@Cacheable("CaraBayarDaoFindByKode")
	Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode,
			@Param("kdDepartemen") String kdDepartemen);

	String QListAll = "select new map(model.id.kdCaraBayar as kdCaraBayar,model.id.kdProfile as kdProfile " + ", model.namaCaraBayar as namaCaraBayar "
			+ ", model.kdCaraBayarHead as kdCaraBayarHead " + ", model.reportDisplay as reportDisplay "
			+ ", model.kodeExternal as kodeExternal " + ", model.namaExternal as namaExternal "
			+ ", model.kdDepartemen as kdDepartemen " + ", model.statusEnabled as statusEnabled "
			+ ", model.noRec as noRec " + ", departemen.namaDepartemen as namaDepartemen, model.version as version )"
			+ " from CaraBayar model left join model.id id left join model.departemen departemen "
			+ " left join model.profile profile where profile.kode =:kdProfile and model.kdDepartemen = :kdDepartemen ";

}
